﻿// cidrCalc_flyout.js
// Copyright (c) 2009 Mark Herring

var strCIDRAddress = null;
var strStartAddr = null;
var strMask = null;
var strInvMask = null;
var strSubnetSize = null;
var strRange = null;
var strEndAddr = null;

function $(strName) {

    //Return an object
    return document.getElementById(strName);
}

function readSetting(strName){

    //Return the relevant setting
    return System.Gadget.Settings.read(strName)
}

function calculate() {

    var arrIPOctet = new Array();

    for (i = 0; i <= 3; i++) {
        if (System.Gadget.document.getElementById("Octet" + (i + 1)).value == "")
            System.Gadget.document.getElementById("Octet" + (i + 1)).value = "0"
        arrIPOctet[i] = System.Gadget.document.getElementById("Octet" + (i + 1)).value;
    }

    var selObj = System.Gadget.document.getElementById("cidr_netmask");
    var selIndex = selObj.selectedIndex;
    strMask = selObj.options[selIndex].text;

    var arrMaskOctet = strMask.split(".");
    
    strInvMask = invertMask(strMask);
    var arrInvOctet = strInvMask.split(".");
    
    var strStartOctet = "";
    var strEndOctet = "";
    
    for (i = 0; i <= 3; i++) {
        //Network address - logical AND with subnet mask
        strStartOctet = (arrIPOctet[i] & arrMaskOctet[i]);

        //Broadcast address - logical OR with inverse mask
        strEndOctet = (arrIPOctet[i] | arrInvOctet[i]);
        if (i < 3) {
            strStartAddr = strStartAddr + strStartOctet + ".";
            strEndAddr = strEndAddr + strEndOctet + ".";
        }
        else {
            var strHostStart = strStartAddr + (parseInt(strStartOctet) + 1);
            var strHostEnd = strEndAddr + (parseInt(strEndOctet) - 1);
            strStartAddr = strStartAddr + strStartOctet;
            strEndAddr = strEndAddr + strEndOctet;
        }
    }

    //build strings
    strCIDRAddress = strStartAddr + "/" + (parseInt(System.Gadget.document.getElementById("cidr_bits").value) + 1);
    strRange = strHostStart + " - " + strHostEnd;
    strSubnetSize = calcSubnetSize();

    //Output the values
	outputValues();
}

function invertMask(strMask) {

    var arrMask = strMask.split(".");
    var invMask = "";
    
    //invert the subnet mask one octet at a time
    for (i = 0; i <= 3; i++) {
        invMask = invMask + (255 - arrMask[i]);
        if (i != 3) {
            invMask = invMask + "."
        }
    }

    return invMask;
}

function calcSubnetSize() {

    var strBits = System.Gadget.document.getElementById("cidr_bits").value;
    
    //calculate the subnet size
    strBits = 31 - (parseInt(strBits));
    if (strBits > 1) {
        return Math.pow(2, strBits) - 2;
    }
    else {
        return Math.pow(2, strBits); 
    }
}

function outputValues() {

    var clipBoardText = '';
    
    //Output values to flyout
    $("cidr_address").value = strCIDRAddress;
    $("cidr_subnet").value = strStartAddr;
    $("cidr_mask").value = strMask;
    $("cidr_invmask").value = strInvMask;
    $("cidr_size").value = strSubnetSize;
    $("cidr_range").value = strRange;
    $("cidr_broadcast").value = strEndAddr;

    //Output values to the clipboard if required
    if (readSetting('autoCopy')) {
        if (readSetting('CIDRAddress')){
            clipBoardText += "CIDR Address: " + strCIDRAddress + "\r\n";
        }
        if (readSetting('NetworkAddress')){
            clipBoardText += "Network Address: " + strStartAddr + "\r\n";
        }
        if (readSetting('SubnetMask')) {
            clipBoardText += "Subnet Mask: " + strMask + "\r\n";
        }
        if (readSetting('InverseMask')) {
            clipBoardText += "Inverse Mask: " + strInvMask + "\r\n";
        }
        if (readSetting('SubnetSize')) {
            clipBoardText += "Subnet Size: " + strSubnetSize + "\r\n";
        }
        if (readSetting('HostRange')) {
            clipBoardText += "Host Range: " + strRange + "\r\n";
        }
        if (readSetting('BroadcastAddress')) {
            clipBoardText += "Broadcast Address: " + strEndAddr;
        }

        //Output the formatted data to the Windows clipboard
        window.clipboardData.setData("Text", clipBoardText);
    }
}